# coding: utf-8

"""
    FiftyTen Service Contracts

    Common API contracts for FiftyTen microservices

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from fiftyten_service_contracts.models.crypto_market_type import CryptoMarketType
from fiftyten_service_contracts.models.exchange_type import ExchangeType
from fiftyten_service_contracts.models.interval import Interval
from fiftyten_service_contracts.models.symbol import Symbol
from typing import Optional, Set
from typing_extensions import Self

class CryptoMarketContext(BaseModel):
    """
    CryptoMarketContext
    """ # noqa: E501
    interval: Interval
    market_category: StrictStr = Field(description="Category of the market", alias="marketCategory")
    exchange_type: ExchangeType = Field(alias="exchangeType")
    symbol: Symbol
    market_type: CryptoMarketType = Field(alias="marketType")
    __properties: ClassVar[List[str]] = ["interval", "marketCategory", "exchangeType", "symbol", "marketType"]

    @field_validator('market_category')
    def market_category_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['crypto']):
            raise ValueError("must be one of enum values ('crypto')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CryptoMarketContext from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CryptoMarketContext from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "interval": obj.get("interval"),
            "marketCategory": obj.get("marketCategory"),
            "exchangeType": obj.get("exchangeType"),
            "symbol": obj.get("symbol"),
            "marketType": obj.get("marketType")
        })
        return _obj


